/***************************************************************************
                          LOW_IPCKeyGeneratorFactory.h  -  description
                             -------------------
    begin                : Tue Jul 30 2002
    copyright            : (C) 2002 by Harald Roelle, Helmut Reiser
    email                : roelle@informatik.uni-muenchen.de, reiser@informatik.uni-muenchen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOW_IPCKEYGENERATORFACTORY_H
#define LOW_IPCKEYGENERATORFACTORY_H


class LOW_IPCKeyGenerator;


/** Factory class for platform specific objects of LOW_IPCKeyGenerator.

    This class also contains platform specific type definitions.

    @see LOW_IPCKeyGenerator

    @author Harald Roelle, Helmut Reiser
 */
class LOW_IPCKeyGeneratorFactory {

//=======================================================================================
public: 

  //=====================================================================================
  //
  // static factory
  //
  
  /** Platform aware replacement for creating dynamic instances of LOW_IPCKeyGenerator.
      @return  Pointer to new instance of LOW_IPCKeyGenerator.
   */
  static LOW_IPCKeyGenerator* new_IPCKeyGenerator();
};

#endif
